/****************************************************************************
**
** Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies).
** All rights reserved.
** Contact: openBossa - INdT (renato.chencarek@openbossa.org)
**
** $QT_BEGIN_LICENSE:LGPL$
** No Commercial Usage
** This file contains pre-release code and may not be distributed.
** You may use this file in accordance with the terms and conditions
** contained in the Technology Preview License Agreement accompanying
** this package.
**
** GNU Lesser General Public License Usage
** Alternatively, this file may be used under the terms of the GNU Lesser
** General Public License version 2.1 as published by the Free Software
** Foundation and appearing in the file LICENSE.LGPL included in the
** packaging of this file.  Please review the following information to
** ensure the GNU Lesser General Public License version 2.1 requirements
** will be met: http://www.gnu.org/licenses/old-licenses/lgpl-2.1.html.
**
** In addition, as a special exception, Nokia gives you certain additional
** rights. These rights are described in the Nokia Qt LGPL Exception
** version 1.1, included in the file LGPL_EXCEPTION.txt in this package.
**
** If you have questions regarding the use of this file, please contact
** the openBossa stream from INdT (renato.chencarek@openbossa.org).
** $QT_END_LICENSE$
**
****************************************************************************/

#ifndef MENUVIEW_H
#define MENUVIEW_H

#include "view.h"

class PhoneView;
class QAbstractAnimation;


class MenuView : public View
{
    Q_OBJECT

public:
    MenuView(QGraphicsItem *parent = 0);

protected slots:
    void onPhoneClicked();

protected:
    int m_vSpacing;
    int m_hSpacing;
    int m_topMargin;
    int m_leftMargin;
    QPointF m_mainIconIPos;
    QPointF m_mainIconFPos;

    Button *m_btnTwitter;
    Button *m_btnEmail;
    Button *m_btnSettings;
    Button *m_btnMusic;
    Button *m_btnNavigation;
    Button *m_btnChat;
    Button *m_btnGames;
    Button *m_btnWeb;
    Button *m_btnFolder;
    Button *m_btnCalendar;
    Button *m_btnCamera;
    Button *m_btnPhone;

    PhoneView *m_phoneView;

    void createStateMachine();
    QAbstractAnimation *createInOutAnimation(bool out);

    Button *addIcon(const QPixmap &pixmap, const QPointF &pos,
                    const char *slot = 0);
};

#endif
